#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int inf = 1e18;
const int mod = 1e9 + 7;

int t;

void solve() {
    string a, b;

    cin >> a >> b;

    string s = "", t = "";

    if (a.size() < b.size()) {
        swap(a, b);
    }

    reverse(all(b));

    while (a.size() != b.size()) {
        b.push_back('#');
    }

    reverse(all(b));

    int n = a.size();

    for (int i = 0; i < n; i++) {
        char t = a[i];

        if (b[i] != '#') {
            t = max(t, b[i]);
        }

        s.push_back(t);
    }

    vector<string> tmp;

    for (int i = 0; i < n; i++) {
        if (b[i] == '#') {
            continue;
        }

        string h = "";

        for (int j = 0; j < n; j++) {
            h.push_back(min(b[i], a[j]));
        }

        tmp.push_back(h);
    }

    char v = char(1);

    if (tmp.size()) {
        t = tmp[0];

        for (int i = 0; i < 10000; i++) {
            t.push_back(v);
        }

        for (int i = 1; i < tmp.size(); i++) {
            for (int j = 0; j < tmp[i].size(); j++) {
                t[i + j] = max(t[i + j], tmp[i][j]);
            }
        }
    }

    cout << s << " ";

    for (int i = 0; i < t.size(); i++) {
        if (t[i] != v) {
            cout << t[i];
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}