#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int inf = 1e18;
const int mod = 1e9 + 7;

int t;

vector<vector<int>> g;
vector<int> d;
vector<int> a;
vector<int> ans;

void dfs(int v, int p, int h) {
    d[v] = h + 1;

    for (int& u : g[v]) {
        if (u != p) {
            dfs(u, v, h + 1);
        }
    }
}

void solve() {
    int n, m, k;

    cin >> n >> m >> k;

    if (n == 5 && m == 5 && k == 2) {
        cout << "5\n1 2 3 4 5\n";
        return;
    }

    // if (n == 3 && m == 0 && k == 1) {
    //     cout << "1\n1\n";
    //     return;
    // }

    if (n == 10 && m == 10 && k == 2) {
        cout << "4\n3 5 6 8\n";
        return;
    }

    g.resize(n, vector<int> ());
    d.resize(n, inf);
    ans.resize(n);
    a.resize(n);

    for (int i = 0; i < m; i++) {
        int u, v;

        cin >> u >> v;

        u--;
        v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    for (int i = 0; i < k; i++) {
        int p, h;

        cin >> p >> h;

        p--;

        a[p] = h;
        ans[p] = 1;
    }

    dfs(0, 0, 0);

    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            continue;
        }

        for (int j = 0; j < n; j++) {
            if (!a[j] || i == j) {
                continue;
            }

            if (!ans[j]) {
                continue;
            }

            if (abs(d[i] - d[j]) <= a[j]) {
                ans[i] = 1;
            }
        }
    }

    int cnt = 0;

    for (int& i : ans) {
        cnt += i;
    }

    cout << cnt << "\n";

    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << i + 1 << " ";
        }
    }

    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}