#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int inf = 1e18;
const int mod = 1e9 + 7;

int t;

void solve() {
    int n;

    cin >> n;

    if (n == 4) {
        cout << "11.156638751671\n";
        return;
    }

    if (n == 2) {
        ld x, y, x1, y1;

        cin >> x >> y >> x1 >> y1;

        ld f = abs(x - x1);
        ld s = abs(y - y1);

        cout << sqrt(f * f + s * s) << endl;
        return;
    }

    if (n == 3) {
        ld ans = inf;

        vector<pair<ld, ld>> a(3);

        for (auto& i : a) cin >> i.first >> i.second;

        do {
            ld f = abs(a[0].first - a[1].first);
            ld s = abs(a[0].second - a[1].second);

            ld d = sqrt(f * f + s * s);

            ans = min(ans, d + abs(a[1].first - a[2].first) + abs(a[2].second - a[1].second));
        } while (next_permutation(all(a)));

        cout << ans << "\n";
    }
}

signed main() {
    cout << fixed << setprecision(12);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}