#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int inf = 1e18;
const int mod = 1e9 + 7;

int t;

void solve() {
    int a, b;

    cin >> a >> b;

    int g = gcd(a, b);

    a /= g;
    b /= g;

    if (a == 1 && b == 1) {
        cout << "R\n";
        return;
    }

    for (int mask = 0; mask < (1 << 20); mask++) {
        int l1 = 0;
        int l2 = 1;

        int r1 = 1;
        int r2 = 0;

        int t1 = 1;
        int t2 = 1;

        string s = "R";

        for (int i = 0; i < 20; i++) {
            if (mask >> i & 1) {
                s.push_back('R');
            } else {
                s.push_back('L');
            }
        }

        for (int i = 1; i < 20; i++) {
            if (s[i] == 'L') {
                r1 = t1;
                r2 = t2;

                t1 += l1;
                t2 += l2;
            } else {
                l1 = t1;
                l2 = t2;

                t1 += r1;
                t2 += r2;
            }

            if (t1 == a && t2 == b) {
                for (int j = 0; j <= i; j++) {
                    cout << s[j];
                }

                return;
            }
        }
    }
}

signed main() {
    // cout << fixed << setprecision(12);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}