#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int inf = 1e18;
const int mod = 1e9 + 7;

int t;

vector<vector<int>> g;
vector<int> a;
vector<int> ans;

vector<int> bfs(int s) {
    int n = a.size();

    vector<int> d(n, inf);

    d[s] = 0;
    queue<int> q;
    q.push(s);

    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (int& u : g[v]) {
            if (d[u] == inf) {
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }

    return d;
}

void solve() {
    int n, m, k;

    cin >> n >> m >> k;

    g.resize(n);
    ans.resize(n);
    a.resize(n);

    for (int i = 0; i < m; i++) {
        int u, v;

        cin >> u >> v;

        u--;
        v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    for (int i = 0; i < k; i++) {
        int p, h;

        cin >> p >> h;

        p--;

        a[p] = h;
        ans[p] = 1;
    }

    for (int i = 0; i < n; i++) {
        if (!a[i]) {
            continue;
        }

        vector<int> d = bfs(i);

        for (int j = 0; j < n; j++) {
            if (d[j] <= a[i]) {
                ans[j] = 1;
            }
        }
    }

    int cnt = 0;

    for (auto& i : ans) {
        cnt += i;
    }

    cout << cnt << "\n";

    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << i + 1 << " ";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}