#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const int inf = 1e18;
const int mod = 1e9 + 7;

int t;

vector<vector<int>> g;
vector<pair<int, int>> a;
vector<int> ans;
vector<int> used;

void dfs(int v, int h) {
    used[v] = 1;
    ans[v] = 1;

    if (h <= 0) {
        return;
    }

    for (int& u : g[v]) {
        if (!used[u]) {
            dfs(u, h - 1);
        }
    }
}

void solve() {
    int n, m, k;

    cin >> n >> m >> k;

    g.resize(n);
    ans.resize(n);

    for (int i = 0; i < m; i++) {
        int u, v;

        cin >> u >> v;

        u--;
        v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    for (int i = 0; i < k; i++) {
        int p, h;

        cin >> p >> h;

        p--;

        a.push_back({p, h});
        ans[p] = 1;
    }

    for (auto& i : a) {
        used.assign(n, 0);

        dfs(i.first, i.second);
    }

    int cnt = 0;

    for (auto& i : ans) {
        cnt += i;
    }

    cout << cnt << "\n";

    for (int i = 0; i < n; i++) {
        if (ans[i]) {
            cout << i + 1 << " ";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}